# V1.0, made by Patch_R, feel free to include this file at your mod...
import App
import MissionLib
import Libs.LibEngineering

pWeapons = None
pPlayer = MissionLib.GetPlayer()
pPower = pPlayer.GetPowerSubsystem()
EnableTimer = None
import Custom.NanoFXv2.ExplosionFX.ExpFX
import Custom.NanoFXv2.NanoFX_ScriptActions
import Custom.NanoFXv2.NanoFX_Lib

def init(): 
	global pWeapons
        pWeapons = Libs.LibEngineering.CreateMenuButton("Overload Weapons", "Tactical", __name__ + ".Stagenull")

def Stagenull(pObject, pEvent):
	pPlayer = MissionLib.GetPlayer()
	pPower = pPlayer.GetPowerSubsystem()
	if not pPlayer:
		return
	Phasers = pPlayer.GetPhaserSystem()
	Pulse = pPlayer.GetPulseWeaponSystem()
	if pPower:
		if Phasers:
			MainBatteryPower = pPower.GetMainBatteryPower()
			MainBatteryLimit = pPower.GetMainBatteryLimit()
		if Pulse:
			MainBatteryPower = pPower.GetMainBatteryPower()
			MainBatteryLimit = pPower.GetMainBatteryLimit()
		if not Phasers and Pulse:
			pWeapons.SetDisabled()
			return
		if (MainBatteryPower < (MainBatteryLimit * 0.3)):
			pSound = App.TGSound_Create("sfx/Bridge/Crew/Engineering/BackupPowerDepleted.mp3", "EPE", 0)
			pSound.SetSFX(0)
			pSound.SetInterface(1)
			App.g_kSoundManager.PlaySound("EPE")			
			return
	Stageone(pObject, pEvent)

def Stageone(pObject, pEvent):
		MainBatteryPower = pPower.GetMainBatteryPower()
		MainBatteryLimit = pPower.GetMainBatteryLimit()
		pPower.SetMainBatteryPower(MainBatteryPower - (MainBatteryLimit * 0.2))
		pPlayer = MissionLib.GetPlayer()
		pSound = App.TGSound_Create("sfx/Bridge/Crew/Tactical/FelixYes4.mp3", "EPE", 0)
		pSound.SetSFX(0)
		pSound.SetInterface(1)
		App.g_kSoundManager.PlaySound("EPE")
		pPropSet = pPlayer.GetPropertySet()
		pPlayerSubSystemPropInstanceList = pPropSet.GetPropertiesByType(App.CT_PHASER_PROPERTY)
		if pPlayerSubSystemPropInstanceList:
			iNumItems = pPlayerSubSystemPropInstanceList.TGGetNumItems()
			pPlayerSubSystemPropInstanceList.TGBeginIteration()
			for i in range(iNumItems):
				pInstance = pPlayerSubSystemPropInstanceList.TGGetNext()
				pProperty = App.PhaserProperty_Cast(pInstance.GetProperty())
				MaxCharge = pProperty.GetMaxCharge()
				MaxDamage = pProperty.GetMaxDamage()
				MaxRecharge = pProperty.GetRechargeRate()
				MaxDamageDistance = pProperty.GetMaxDamageDistance()
				pProperty.SetMaxDamage(MaxDamage * 1.1)
				pProperty.SetMaxCharge(MaxCharge * 1.2)
				pProperty.SetRechargeRate(MaxRecharge * 1.5)
				pProperty.SetMaxDamageDistance(MaxDamageDistance * 1.2)
		pPlayerSubSystemPropInstanceList = pPropSet.GetPropertiesByType(App.CT_PULSE_WEAPON_PROPERTY)
		if pPlayerSubSystemPropInstanceList:
			iNumItems = pPlayerSubSystemPropInstanceList.TGGetNumItems()
			pPlayerSubSystemPropInstanceList.TGBeginIteration()
			for i in range(iNumItems):
				pInstance = pPlayerSubSystemPropInstanceList.TGGetNext()
				pProperty = App.PulseWeaponProperty_Cast(pInstance.GetProperty())
				pName = pProperty.GetName().GetCString()
				MaxPulseCharge = pProperty.GetMaxCharge()
				MaxPulseDamage = pProperty.GetMaxDamage()
				MaxPulseDamageDistance = pProperty.GetMaxDamageDistance()
				PulseRechargeRate = pProperty.GetRechargeRate()
				pProperty.SetMaxCharge(MaxPulseCharge * 1.5)
				pProperty.SetMaxDamage(MaxPulseDamage * 1.25)
				pProperty.SetMaxDamageDistance(MaxPulseDamageDistance * 1.2)
				pProperty.SetRechargeRate(PulseRechargeRate * 1.2)
		Time = App.g_kSystemWrapper.GetRandomNumber(240) + 60
		EnableTimer = MissionLib.CreateTimer(Libs.LibEngineering.GetEngineeringNextEventType(), __name__ + ".Stagetwo", App.g_kUtopiaModule.GetGameTime() + Time, 0, 0)		
		pWeapons.SetDisabled()
		
def Stagetwo(pObject, pEvent):
	pPlayer = MissionLib.GetPlayer()
	PhaserWeapons = pPlayer.GetPhaserSystem()
	if PhaserWeapons:
		iWeapons = PhaserWeapons.GetNumChildSubsystems()
		for iWeap in range(iWeapons):
			weapdamage = ((App.g_kSystemWrapper.GetRandomNumber(20)+80)*0.01)
			qWeaponChild = PhaserWeapons.GetChildSubsystem(iWeap)
			if qWeaponChild:
				if str(qWeaponChild) != str(PhaserWeapons):
					condition = qWeaponChild.GetCondition()
					chance = App.g_kSystemWrapper.GetRandomNumber(10)
					if (chance < 5):
						qWeaponChild.SetCondition(condition * weapdamage)
						pSequence = App.TGSequence_Create()
						pSet = pPlayer.GetContainingSet()
						pEmitFrom = App.TGModelUtils_CastNodeToAVObject(pPlayer.GetNode())
						pPlayerNode = pPlayer.GetNode()
						pAttachTo = pSet.GetEffectRoot() 
						vEmitPos  = qWeaponChild.GetPosition()
						vEmitDir  = App.NiPoint3(1, 1, 1)
						fSize     = pPlayer.GetRadius() * 0.10
						sFile     = Custom.NanoFXv2.ExplosionFX.ExpFX.GetNanoGfxFile("ExplosionGfx", "scripts/Custom/NanoFXv2/ExplosionFX/Gfx/Explosions/")
						pSound = Custom.NanoFXv2.ExplosionFX.ExpFX.CreateNanoSoundSeq(pPlayer, "ExpMedSfx")
						pSequence.AddAction(pSound)	
						pExplosion = Custom.NanoFXv2.NanoFX_ScriptActions.CreateControllerFX(sFile, pEmitFrom, pPlayerNode, fSize, vEmitPos, fLifeTime = 1.0)
						pSequence.AddAction(pExplosion)
						pSparks = Custom.NanoFXv2.ExplosionFX.ExpFX.CreateExpSparkSeq(fSize, pEmitFrom, pPlayerNode, vEmitPos, vEmitDir)
						pSequence.AddAction(pSparks, App.TGAction_CreateNull(), 0.5)
						pDebris = Custom.NanoFXv2.ExplosionFX.ExpFX.CreateNanoDebrisSeq(fSize, pEmitFrom, pSet.GetEffectRoot(), vEmitPos, vEmitDir)
						pSequence.AddAction(pDebris, App.TGAction_CreateNull(), 0.5)				
						pSequence.Play()
	PulseWeapons = pPlayer.GetPulseWeaponSystem()
	if PulseWeapons:	
		iWeapons = PulseWeapons.GetNumChildSubsystems()
		for iWeap in range(iWeapons):
			weapdamage = ((App.g_kSystemWrapper.GetRandomNumber(20)+80)*0.01)
			qWeaponChild = PulseWeapons.GetChildSubsystem(iWeap)
			if qWeaponChild:
				if str(qWeaponChild) != str(PulseWeapons):
					condition = qWeaponChild.GetCondition()
					chance = App.g_kSystemWrapper.GetRandomNumber(10)
					if (chance < 4):
						qWeaponChild.SetCondition(condition * weapdamage)
						pSequence = App.TGSequence_Create()
						pSet = pPlayer.GetContainingSet()
						pEmitFrom = App.TGModelUtils_CastNodeToAVObject(pPlayer.GetNode())
						pPlayerNode = pPlayer.GetNode()
						pAttachTo = pSet.GetEffectRoot() 
						vEmitPos  = qWeaponChild.GetPosition()
						vEmitDir  = App.NiPoint3(1, 1, 1)
						fSize     = pPlayer.GetRadius() * 0.08
						sFile     = Custom.NanoFXv2.ExplosionFX.ExpFX.GetNanoGfxFile("ExplosionGfx", "scripts/Custom/NanoFXv2/ExplosionFX/Gfx/Explosions/")
						pSound = Custom.NanoFXv2.ExplosionFX.ExpFX.CreateNanoSoundSeq(pPlayer, "ExpMedSfx")
						pSequence.AddAction(pSound)	
						pExplosion = Custom.NanoFXv2.NanoFX_ScriptActions.CreateControllerFX(sFile, pEmitFrom, pPlayerNode, fSize, vEmitPos, fLifeTime = 1.0)
						pSequence.AddAction(pExplosion)
						pSparks = Custom.NanoFXv2.ExplosionFX.ExpFX.CreateExpSparkSeq(fSize, pEmitFrom, pPlayerNode, vEmitPos, vEmitDir)
						pSequence.AddAction(pSparks, App.TGAction_CreateNull(), 0.5)
						pDebris = Custom.NanoFXv2.ExplosionFX.ExpFX.CreateNanoDebrisSeq(fSize, pEmitFrom, pSet.GetEffectRoot(), vEmitPos, vEmitDir)
						pSequence.AddAction(pDebris, App.TGAction_CreateNull(), 0.5)				
						pSequence.Play()
		pSound = App.TGSound_Create("sfx/Bridge/Overload.mp3", "EPE", 0)
		pSound.SetSFX(0)
		pSound.SetInterface(1)
		App.g_kSoundManager.PlaySound("EPE")
	if	PhaserWeapons:
		pPropSet = pPlayer.GetPropertySet()
		pPlayerSubSystemPropInstanceList = pPropSet.GetPropertiesByType(App.CT_PHASER_PROPERTY)
		if pPlayerSubSystemPropInstanceList:
			iNumItems = pPlayerSubSystemPropInstanceList.TGGetNumItems()
			pPlayerSubSystemPropInstanceList.TGBeginIteration()
			for i in range(iNumItems):
				pInstance = pPlayerSubSystemPropInstanceList.TGGetNext()
				pProperty = App.PhaserProperty_Cast(pInstance.GetProperty())
				MaxCharge = pProperty.GetMaxCharge()
				MaxDamage = pProperty.GetMaxDamage()
				MaxRecharge = pProperty.GetRechargeRate()
				MaxDamageDistance = pProperty.GetMaxDamageDistance()
				pProperty.SetMaxDamage(MaxDamage / 1.1)
				pProperty.SetMaxCharge(MaxCharge * 1.2)
				pProperty.SetRechargeRate(MaxRecharge / 1.5)
				pProperty.SetMaxDamageDistance(MaxDamageDistance / 1.2)
	if PulseWeapons:
		pPropSet = pPlayer.GetPropertySet()
		pPlayerSubSystemPropInstanceList = pPropSet.GetPropertiesByType(App.CT_PULSE_WEAPON_PROPERTY)
		if pPlayerSubSystemPropInstanceList:
			iNumItems = pPlayerSubSystemPropInstanceList.TGGetNumItems()
			pPlayerSubSystemPropInstanceList.TGBeginIteration()
			for i in range(iNumItems):
				pInstance = pPlayerSubSystemPropInstanceList.TGGetNext()
				pProperty = App.PulseWeaponProperty_Cast(pInstance.GetProperty())
				pName = pProperty.GetName().GetCString()
				MaxPulseCharge = pProperty.GetMaxCharge()
				MaxPulseDamage = pProperty.GetMaxDamage()
				MaxPulseDamageDistance = pProperty.GetMaxDamageDistance()
				PulseRechargeRate = pProperty.GetRechargeRate()
				pProperty.SetMaxCharge(MaxPulseCharge / 1.5)
				pProperty.SetMaxDamage(MaxPulseDamage / 1.25)
				pProperty.SetMaxDamageDistance(MaxPulseDamageDistance / 1.2)
				pProperty.SetRechargeRate(PulseRechargeRate / 1.2)
	EnableTimer = MissionLib.CreateTimer(Libs.LibEngineering.GetEngineeringNextEventType(), __name__ + ".Stageend", App.g_kUtopiaModule.GetGameTime() + 1, 0, 0)		

def Stageend(pObject, pEvent):
		pPlayer = MissionLib.GetPlayer()
		pSound = App.TGSound_Create("sfx/Bridge/Crew/Tactical/gt020.mp3", "EPE", 0)
		pSound.SetSFX(0)
		pSound.SetInterface(1)
		App.g_kSoundManager.PlaySound("EPE")
		pWeapons.SetEnabled()