# V1.0, made by Patch_R, feel free to include this file at your mod...
import App
import MissionLib
import Libs.LibEngineering

global ImpEngMaxSpeed
pEngines = None
pPlayer = MissionLib.GetPlayer()
pShields = pPlayer.GetShields()
pPower = pPlayer.GetPowerSubsystem()
EnableTimer = None
ImpEng = pPlayer.GetImpulseEngineSubsystem()
ImpEngMaxSpeed = ImpEng.GetMaxSpeed()
ImpEngMaxAccel = ImpEng.GetMaxAccel()
import Custom.NanoFXv2.ExplosionFX.ExpFX
import Custom.NanoFXv2.NanoFX_ScriptActions
import Custom.NanoFXv2.NanoFX_Lib

def init(): 
	global pEngines
        pEngines = Libs.LibEngineering.CreateMenuButton("Overload Impulse", "Helm", __name__ + ".Impulseboost")

#drain power, check power levels
def Impulseboost(pObject, pEvent):
	pPlayer = MissionLib.GetPlayer()
	if not pPlayer:
		return
	if pPower:
		if ImpEng:
			if ImpEng.IsOn():
				MainBatteryPower = pPower.GetMainBatteryPower()
				MainBatteryLimit = pPower.GetMainBatteryLimit()
				if (MainBatteryPower < (MainBatteryLimit * 0.2)):
					pSound = App.TGSound_Create("sfx/Bridge/Crew/Engineering/BackupPowerDepleted.mp3", "EPE", 0)
					pSound.SetSFX(0)
					pSound.SetInterface(1)
					App.g_kSoundManager.PlaySound("EPE")			
					return
				pSound = App.TGSound_Create("sfx/Bridge/Crew/Helm/gh007.mp3", "EPE", 0)
				pSound.SetSFX(0)
				pSound.SetInterface(1)
				App.g_kSoundManager.PlaySound("EPE")
				EnableTimer = MissionLib.CreateTimer(Libs.LibEngineering.GetEngineeringNextEventType(), __name__ + ".Stageone", App.g_kUtopiaModule.GetGameTime() + 2, 0, 0)

		else:
			pEngines.SetDisabled()
			return
	else:
		pEngines.SetDisabled()
		return
#boost engines
def Stageone(pObject, pEvent):
		pPlayer = MissionLib.GetPlayer()
		ImpEng = pPlayer.GetImpulseEngineSubsystem()
		MainBatteryPower = pPower.GetMainBatteryPower()
		MainBatteryLimit = pPower.GetMainBatteryLimit()		
		pSound = App.TGSound_Create("sfx/Maelstrom/Episode 2/Mission 2/E2M2BrexCom4.mp3", "EPE", 0)
		pSound.SetSFX(0)
		pSound.SetInterface(1)
		App.g_kSoundManager.PlaySound("EPE")	
		pPower.SetMainBatteryPower(MainBatteryPower - (MainBatteryLimit * 0.3))
		ImpEng.GetProperty().SetMaxSpeed(ImpEngMaxSpeed*1.2)
		ImpEng.GetProperty().SetMaxAccel(ImpEngMaxAccel*1.2)
		DisableButton()

#script main run time		
def DisableButton():
	global pEngines
	pEngines.SetDisabled()
	Time = App.g_kSystemWrapper.GetRandomNumber(240) + 60
	EnableTimer = MissionLib.CreateTimer(Libs.LibEngineering.GetEngineeringNextEventType(), __name__ + ".EnableButton", App.g_kUtopiaModule.GetGameTime() + Time, 0, 0)

#the overload sound, and a little delay
def EnableButton(pObject, pEvent):
	pSound = App.TGSound_Create("sfx/Bridge/Overload.mp3", "EPE", 0)
	pSound.SetSFX(0)
	pSound.SetInterface(1)
	App.g_kSoundManager.PlaySound("EPE")
	EnableTimer = MissionLib.CreateTimer(Libs.LibEngineering.GetEngineeringNextEventType(), __name__ + ".Stagefour", App.g_kUtopiaModule.GetGameTime() + 3, 0, 0)

#restore engines to normal, reenable button	
def Stagefour(pObject, pEvent):
	global pEngines
	pEngines.SetEnabled()
	pPlayer = MissionLib.GetPlayer()
	ImpEng = pPlayer.GetImpulseEngineSubsystem()
	ImpEng.GetProperty().SetMaxSpeed(ImpEngMaxSpeed)
	ImpEng.GetProperty().SetMaxAccel(ImpEngMaxAccel)
	EnableTimer = MissionLib.CreateTimer(Libs.LibEngineering.GetEngineeringNextEventType(), __name__ + ".Stagefive", App.g_kUtopiaModule.GetGameTime() + 1, 0, 0)

#do some dramange to impulse engines, kiska speaks...
def Stagefive(pObject, pEvent):
	pSound = App.TGSound_Create("sfx/Bridge/Crew/Helm/ImpulseDamaged.mp3", "EPE", 0)
	pSound.SetSFX(0)
	pSound.SetInterface(1)
	App.g_kSoundManager.PlaySound("EPE")
	pPlayer = MissionLib.GetPlayer()
	pShip = MissionLib.GetPlayer()
	ImpEng = pPlayer.GetImpulseEngineSubsystem()
	iNumEng = ImpEng.GetNumChildSubsystems()
	for iEng in range(iNumEng):
		impdamage = ((App.g_kSystemWrapper.GetRandomNumber(20)+80)*0.01)
		qEngChild = ImpEng.GetChildSubsystem(iEng)
		if qEngChild:
			if str(qEngChild) != str(ImpEng):
				chance = App.g_kSystemWrapper.GetRandomNumber(9)
				if (chance < 6):
					condition = qEngChild.GetCondition()
					qEngChild.SetCondition(condition * impdamage)
					pSequence = App.TGSequence_Create()
					pSet = pShip.GetContainingSet()
					pEmitFrom = App.TGModelUtils_CastNodeToAVObject(pShip.GetNode())
					pShipNode = pShip.GetNode()
					pAttachTo = pSet.GetEffectRoot() 
					vEmitPos  = qEngChild.GetPosition()
					vEmitDir  = App.NiPoint3(1, 1, 1)
					fSize     = pShip.GetRadius() * 0.08
					sFile     = Custom.NanoFXv2.ExplosionFX.ExpFX.GetNanoGfxFile("ExplosionGfx", "scripts/Custom/NanoFXv2/ExplosionFX/Gfx/Explosions/")
					pSound = Custom.NanoFXv2.ExplosionFX.ExpFX.CreateNanoSoundSeq(pShip, "ExpMedSfx")
					pSequence.AddAction(pSound)	
					pExplosion = Custom.NanoFXv2.NanoFX_ScriptActions.CreateControllerFX(sFile, pEmitFrom, pShipNode, fSize, vEmitPos, fLifeTime = 1.0)
					pSequence.AddAction(pExplosion)
					pSparks = Custom.NanoFXv2.ExplosionFX.ExpFX.CreateExpSparkSeq(fSize, pEmitFrom, pShipNode, vEmitPos, vEmitDir)
					pSequence.AddAction(pSparks, App.TGAction_CreateNull(), 0.5)
					pDebris = Custom.NanoFXv2.ExplosionFX.ExpFX.CreateNanoDebrisSeq(fSize, pEmitFrom, pSet.GetEffectRoot(), vEmitPos, vEmitDir)
					pSequence.AddAction(pDebris, App.TGAction_CreateNull(), 0.5)				
					pSequence.Play()