# V1.0, made by Patch_R, feel free to include this file at your mod...
import App
import MissionLib
import Libs.LibEngineering

pPlayer = MissionLib.GetPlayer()
pShields = pPlayer.GetShields()
pPower = pPlayer.GetPowerSubsystem()
EnableTimer = None
import Custom.NanoFXv2.ExplosionFX.ExpFX
import Custom.NanoFXv2.NanoFX_ScriptActions
import Custom.NanoFXv2.NanoFX_Lib

def init(): 
	global pShieldsButton
        pShieldsButton = Libs.LibEngineering.CreateMenuButton("Overload Shields", "Engineering", __name__ + ".Stagenull")

def Stagenull(pObject, pEvent):
	pPlayer = MissionLib.GetPlayer()
	pShields = pPlayer.GetShields()
	if (pShields.IsOn() and not pShields.IsDisabled()):
		if not pPlayer:
			return
		if pPower:
			if pShields:
				MainBatteryPower = pPower.GetMainBatteryPower()
				MainBatteryLimit = pPower.GetMainBatteryLimit()
				if (MainBatteryPower < (MainBatteryLimit * 0.3)):
					pSound = App.TGSound_Create("sfx/Bridge/Crew/Engineering/BackupPowerDepleted.mp3", "EPE", 0)
					pSound.SetSFX(0)
					pSound.SetInterface(1)
					App.g_kSoundManager.PlaySound("EPE")			
					return
				pPower.SetMainBatteryPower(MainBatteryPower - (MainBatteryLimit * 0.2))
				pSound = App.TGSound_Create("sfx/Bridge/Crew/Engineering/ge0140.mp3", "EPE", 0)
				pSound.SetSFX(0)
				pSound.SetInterface(1)
				App.g_kSoundManager.PlaySound("EPE")
				EnableTimer = MissionLib.CreateTimer(Libs.LibEngineering.GetEngineeringNextEventType(), __name__ + ".Stageone", App.g_kUtopiaModule.GetGameTime() + 2, 0, 0)

			else:
				pShields.SetDisabled()
				return
		else:
			pShields.SetDisabled()
			return

def Stageone(pObject, pEvent):
	pPlayer = MissionLib.GetPlayer()
	pShields = pPlayer.GetShields()
	ShieldMax = 0
	pPlayer = MissionLib.GetPlayer()
	if pShields:
		for Shield in range(App.ShieldClass.NUM_SHIELDS):
			ShieldMax = 1.1 * pShields.GetMaxShields(Shield)
			ShieldReload = 1.3 * pShields.GetShieldChargePerSecond(Shield)
			if ShieldMax == 0.0:
				ShieldMax = 0.1	#Defiant's fix
			pShields.GetProperty().SetMaxShields(Shield, ShieldMax)
			pShields.GetProperty().SetShieldChargePerSecond(Shield, ShieldReload)
	DisableButton()

def DisableButton():
	global pShieldsButton
	pShieldsButton.SetDisabled()
	Time = App.g_kSystemWrapper.GetRandomNumber(240) + 60
	EnableTimer = MissionLib.CreateTimer(Libs.LibEngineering.GetEngineeringNextEventType(), __name__ + ".EnableButton", App.g_kUtopiaModule.GetGameTime() + Time, 0, 0)
	
def EnableButton(pObject, pEvent):
	pShieldsButton.SetEnabled()
	pSound = App.TGSound_Create("sfx/Bridge/Overload.mp3", "EPE", 0)
	pSound.SetSFX(0)
	pSound.SetInterface(1)
	App.g_kSoundManager.PlaySound("EPE")
	pPlayer = MissionLib.GetPlayer()
	pShields = pPlayer.GetShields()
	pPlayer = MissionLib.GetPlayer()
	if pShields:
		condition = pShields.GetCondition()
		shielddamage = ((App.g_kSystemWrapper.GetRandomNumber(20)+80)*0.01)
		chance = App.g_kSystemWrapper.GetRandomNumber(10)
		if (chance < 5):
			pShields.SetCondition(condition * shielddamage)
			pSequence = App.TGSequence_Create()
			pSet = pPlayer.GetContainingSet()
			pEmitFrom = App.TGModelUtils_CastNodeToAVObject(pPlayer.GetNode())
			pPlayerNode = pPlayer.GetNode()
			pAttachTo = pSet.GetEffectRoot() 
			vEmitPos  = pShields.GetPosition()
			vEmitDir  = App.NiPoint3(1, 1, 1)
			fSize     = pPlayer.GetRadius() * 0.10
			sFile     = Custom.NanoFXv2.ExplosionFX.ExpFX.GetNanoGfxFile("ExplosionGfx", "scripts/Custom/NanoFXv2/ExplosionFX/Gfx/Explosions/")
			pSound = Custom.NanoFXv2.ExplosionFX.ExpFX.CreateNanoSoundSeq(pPlayer, "ExpMedSfx")
			pSequence.AddAction(pSound)	
			pExplosion = Custom.NanoFXv2.NanoFX_ScriptActions.CreateControllerFX(sFile, pEmitFrom, pPlayerNode, fSize, vEmitPos, fLifeTime = 1.0)
			pSequence.AddAction(pExplosion)
			pSparks = Custom.NanoFXv2.ExplosionFX.ExpFX.CreateExpSparkSeq(fSize, pEmitFrom, pPlayerNode, vEmitPos, vEmitDir)
			pSequence.AddAction(pSparks, App.TGAction_CreateNull(), 0.5)
			pDebris = Custom.NanoFXv2.ExplosionFX.ExpFX.CreateNanoDebrisSeq(fSize, pEmitFrom, pSet.GetEffectRoot(), vEmitPos, vEmitDir)
			pSequence.AddAction(pDebris, App.TGAction_CreateNull(), 0.5)				
			pSequence.Play()
		for Shield in range(App.ShieldClass.NUM_SHIELDS):
			ShieldMax = pShields.GetMaxShields(Shield) / 1.3
			ShieldReload = pShields.GetShieldChargePerSecond(Shield) / 1.3
			if ShieldMax == 0.0:
				ShieldMax = 0.1	#Defiant's fix
			pShields.GetProperty().SetMaxShields(Shield, ShieldMax)
			pShields.GetProperty().SetShieldChargePerSecond(Shield, ShieldReload)