# V1.0, made by Patch_R, feel free to include this file at your mod...
import App
import MissionLib
import Libs.LibEngineering
import Bridge.BridgeUtils
import Custom.NanoFXv2.ExplosionFX.ExpFX
import Custom.NanoFXv2.NanoFX_ScriptActions
import Custom.NanoFXv2.NanoFX_Lib

DamagedSystemsNumber = None
pBrexMenu = Bridge.BridgeUtils.GetBridgeMenu('Engineer')
EnableTimer = None
pButtonOrder = None
choice = None
dodamage = None
i = None
effect = None

#make menu
def init():
	global pBrexMenu, pButtonNormal, pButtonDanger, pButtonExtreme, pButtonLimit, pButtonOrder
	pButtonOrder = App.STMenu_CreateW(App.TGString("Overload Warpcore"))
	pBrexMenu.PrependChild(pButtonOrder)
	
	pButtonNormal = App.STMenu_CreateW(App.TGString("Normal overload"))
	pButtonOrder.PrependChild(pButtonNormal)
	
	pButtonDanger = App.STMenu_CreateW(App.TGString("Dangerous overload"))
	pButtonOrder.PrependChild(pButtonDanger)
	
	pButtonExtreme = App.STMenu_CreateW(App.TGString("Extreme overload"))
	pButtonOrder.PrependChild(pButtonExtreme)
	
	pButtonLimit = App.STMenu_CreateW(App.TGString("Beyound all limits"))
	pButtonOrder.PrependChild(pButtonLimit)
	
	Libs.LibEngineering.CreateMenuButton("Set Core to 110%", "Engineering", __name__ + ".pButtonOrderNormal", 0, pButtonNormal)
	Libs.LibEngineering.CreateMenuButton("Set Core to 125%", "Engineering", __name__ + ".pButtonOrderDanger", 0, pButtonDanger)
	Libs.LibEngineering.CreateMenuButton("Set Core to 140%", "Engineering", __name__ + ".pButtonOrderExtreme", 0, pButtonExtreme)
	Libs.LibEngineering.CreateMenuButton("Set Core to maximum!", "Engineering", __name__ + ".pButtonOrderLimit", 0, pButtonLimit)


#handle buttons
def pButtonOrderNormal(pObject, pEvent):
	global effect
	if not effect == 1:
		effect = 1
		EnableTimer = MissionLib.CreateTimer(Libs.LibEngineering.GetEngineeringNextEventType(), __name__ + ".Normaloverload", App.g_kUtopiaModule.GetGameTime() + 1, 0, 0)
		disblaebuttons(pObject, pEvent)

def pButtonOrderDanger(pObject, pEvent):
	global effect
	if not effect == 1:
		effect = 1
		EnableTimer = MissionLib.CreateTimer(Libs.LibEngineering.GetEngineeringNextEventType(), __name__ + ".Dangerousoverload", App.g_kUtopiaModule.GetGameTime() + 1, 0, 0)
		disblaebuttons(pObject, pEvent)

def pButtonOrderExtreme(pObject, pEvent):
	global effect
	if not effect == 1:
		effect = 1
		EnableTimer = MissionLib.CreateTimer(Libs.LibEngineering.GetEngineeringNextEventType(), __name__ + ".Extremeoverload", App.g_kUtopiaModule.GetGameTime() + 1, 0, 0)
		disblaebuttons(pObject, pEvent)

def pButtonOrderLimit(pObject, pEvent):
	global effect
	if not effect == 1:
		effect = 1
		EnableTimer = MissionLib.CreateTimer(Libs.LibEngineering.GetEngineeringNextEventType(), __name__ + ".Limitsoverload", App.g_kUtopiaModule.GetGameTime() + 1, 0, 0)
		disblaebuttons(pObject, pEvent)

#handle buttons
def disblaebuttons(pObject, pEvent):
	global pButtonNormal, pButtonDanger, pButtonExtreme, pButtonLimit, pButtonOrder
	pSound = App.TGSound_Create("sfx/Bridge/Crew/Engineering/ge006.mp3", "EPE", 0)
	pSound.SetSFX(0)
	pSound.SetInterface(1)
	App.g_kSoundManager.PlaySound("EPE")
	pButtonNormal.SetDisabled()
	pButtonDanger.SetDisabled()
	pButtonExtreme.SetDisabled()
	pButtonLimit.SetDisabled()
	pButtonOrder.SetDisabled()

def enablebuttons(pObject, pEvent):
	global pButtonNormal, pButtonDanger, pButtonExtreme, pButtonLimit, pButtonOrder
	pButtonNormal.SetEnabled()
	pButtonDanger.SetEnabled()
	pButtonExtreme.SetEnabled()
	pButtonLimit.SetEnabled()
	pButtonOrder.SetEnabled()

# set the core overload	
def Normaloverload(pObject, pEvent):
	global choice
	choice = 1
	pPlayer = MissionLib.GetPlayer()
	pPower = pPlayer.GetPowerSubsystem()
	powerout = pPower.GetPowerOutput()
	conducit = pPower.GetMainConduitCapacity()
	backup = pPower.GetBackupConduitCapacity()
	pPower.GetProperty().SetPowerOutput(powerout * 1.1)
	pPower.GetProperty().SetMainConduitCapacity(conducit * 1.1)
	pPower.GetProperty().SetBackupConduitCapacity(backup * 1.1)
	Time = App.g_kSystemWrapper.GetRandomNumber(440) + 120
	EnableTimer = MissionLib.CreateTimer(Libs.LibEngineering.GetEngineeringNextEventType(), __name__ + ".resetpower", App.g_kUtopiaModule.GetGameTime() + Time, 0, 0)

	
def Dangerousoverload(pObject, pEvent):
	global choice
	choice = 2
	pPlayer = MissionLib.GetPlayer()
	pPower = pPlayer.GetPowerSubsystem()
	powerout = pPower.GetPowerOutput()
	conducit = pPower.GetMainConduitCapacity()
	backup = pPower.GetBackupConduitCapacity()
	pPower.GetProperty().SetPowerOutput(powerout * 1.25)
	pPower.GetProperty().SetMainConduitCapacity(conducit * 1.25)
	pPower.GetProperty().SetBackupConduitCapacity(backup * 1.25)
	Time = App.g_kSystemWrapper.GetRandomNumber(360) + 100
	EnableTimer = MissionLib.CreateTimer(Libs.LibEngineering.GetEngineeringNextEventType(), __name__ + ".damagecalculat", App.g_kUtopiaModule.GetGameTime() + Time, 0, 0)

	
def Extremeoverload(pObject, pEvent):
	global choice
	choice = 3
	pPlayer = MissionLib.GetPlayer()
	pPower = pPlayer.GetPowerSubsystem()
	powerout = pPower.GetPowerOutput()
	conducit = pPower.GetMainConduitCapacity()
	backup = pPower.GetBackupConduitCapacity()
	pPower.GetProperty().SetPowerOutput(powerout * 1.4)
	pPower.GetProperty().SetMainConduitCapacity(conducit * 1.4)
	pPower.GetProperty().SetBackupConduitCapacity(backup * 1.4)
	Time = App.g_kSystemWrapper.GetRandomNumber(260) + 60
	EnableTimer = MissionLib.CreateTimer(Libs.LibEngineering.GetEngineeringNextEventType(), __name__ + ".damagecalculat", App.g_kUtopiaModule.GetGameTime() + Time, 0, 0)

	
def Limitsoverload(pObject, pEvent):
	global choice
	choice = 4
	pPlayer = MissionLib.GetPlayer()
	pPower = pPlayer.GetPowerSubsystem()
	powerout = pPower.GetPowerOutput()
	conducit = pPower.GetMainConduitCapacity()
	backup = pPower.GetBackupConduitCapacity()
	pPower.GetProperty().SetPowerOutput(powerout * 1.6)
	pPower.GetProperty().SetMainConduitCapacity(conducit * 1.6)
	pPower.GetProperty().SetBackupConduitCapacity(backup * 1.6)
	Time = App.g_kSystemWrapper.GetRandomNumber(170) + 30
	EnableTimer = MissionLib.CreateTimer(Libs.LibEngineering.GetEngineeringNextEventType(), __name__ + ".damagecalculat", App.g_kUtopiaModule.GetGameTime() + Time, 0, 0)

def damagecalculat(pObject, pEvent):
	global dodamage, i
	i = 0
	if choice == 2:
		dodamage = App.g_kSystemWrapper.GetRandomNumber(3) + 1
	if choice == 3:
		dodamage = App.g_kSystemWrapper.GetRandomNumber(3) + 2
	if choice == 4:
		dodamage = App.g_kSystemWrapper.GetRandomNumber(3) + 3
	Damage(pObject, pEvent)

#Damage some systems, and nanofx
def Damage(pObject, pEvent):
	global dodamage, pSequence, pSet, pEmitFrom, pPlayerNode, pAttachTo, vEmitPos, i
	pPlayer = MissionLib.GetPlayer()
	while i < dodamage:
		i = i + 1
		if choice == 2:
			systemdamagepercent = ((App.g_kSystemWrapper.GetRandomNumber(20)+80)*0.01)
			DamagedSystemsNumber = App.g_kSystemWrapper.GetRandomNumber(5) + 1
		if choice == 3: 
			systemdamagepercent = ((App.g_kSystemWrapper.GetRandomNumber(30)+70)*0.01)
			DamagedSystemsNumber = App.g_kSystemWrapper.GetRandomNumber(5) + 1
		if choice == 4:
			systemdamagepercent = ((App.g_kSystemWrapper.GetRandomNumber(40)+60)*0.01)
			DamagedSystemsNumber = App.g_kSystemWrapper.GetRandomNumber(5) + 1
		if pPlayer:
			pPower = pPlayer.GetPowerSubsystem()
			pShields = pPlayer.GetShields()
			pEng = pPlayer.GetImpulseEngineSubsystem()
			pSensors = pPlayer.GetSensorSubsystem()
			pPhasers = pPlayer.GetPhaserSystem()
			pPulse = pPlayer.GetPulseWeaponSystem()
			pWarp = pPlayer.GetWarpEngineSubsystem()
			if pPower and DamagedSystemsNumber == 1:
				powercon = pPower.GetCondition()
				pPower.SetCondition(powercon * systemdamagepercent)
				pSequence = App.TGSequence_Create()
				pSet = pPlayer.GetContainingSet()
				pEmitFrom = App.TGModelUtils_CastNodeToAVObject(pPlayer.GetNode())
				pPlayerNode = pPlayer.GetNode()
				pAttachTo = pSet.GetEffectRoot() 
				vEmitPos  = pPower.GetPosition()
				nanofx(pObject, pEvent)
			if pShields and DamagedSystemsNumber == 2:
				shieldcond = pShields.GetCondition()
				pShields.SetCondition(shieldcond * systemdamagepercent)
				pSequence = App.TGSequence_Create()
				pSet = pPlayer.GetContainingSet()
				pEmitFrom = App.TGModelUtils_CastNodeToAVObject(pPlayer.GetNode())
				pPlayerNode = pPlayer.GetNode()
				pAttachTo = pSet.GetEffectRoot() 
				vEmitPos  = pShields.GetPosition()
				nanofx(pObject, pEvent)
			if pEng and DamagedSystemsNumber == 3:
				iNumEng = pEng.GetNumChildSubsystems()
				for iEng in range(iNumEng):
					qEngChild = pEng.GetChildSubsystem(iEng)
					if qEngChild:
						if str(qEngChild) != str(pEng):
							damagechance = App.g_kSystemWrapper.GetRandomNumber(10)
							if (damagechance < 4):
								condition = qEngChild.GetCondition()
								qEngChild.SetCondition(condition * systemdamagepercent)
								pSequence = App.TGSequence_Create()
								pSet = pPlayer.GetContainingSet()
								pEmitFrom = App.TGModelUtils_CastNodeToAVObject(pPlayer.GetNode())
								pPlayerNode = pPlayer.GetNode()
								pAttachTo = pSet.GetEffectRoot() 
								vEmitPos  = qEngChild.GetPosition()
								nanofx(pObject, pEvent)
			if pSensors and DamagedSystemsNumber == 4:
				sensorcond = pSensors.GetCondition()
				pSensors.SetCondition(sensorcond * systemdamagepercent)
				pSequence = App.TGSequence_Create()
				pSet = pPlayer.GetContainingSet()
				pEmitFrom = App.TGModelUtils_CastNodeToAVObject(pPlayer.GetNode())
				pPlayerNode = pPlayer.GetNode()
				pAttachTo = pSet.GetEffectRoot() 
				vEmitPos  = pSensors.GetPosition()
				nanofx(pObject, pEvent)
			if pWarp and DamagedSystemsNumber == 5:
				iNumWarp = pWarp.GetNumChildSubsystems()
				for iwarp in range(iNumWarp):
					qWarpChild = pWarp.GetChildSubsystem(iwarp)
					if qWarpChild:
						if str(qWarpChild) != str(pWarp):
							damagechance = App.g_kSystemWrapper.GetRandomNumber(10)
							if (damagechance < 4):
								warpcondition = qWarpChild.GetCondition()
								qWarpChild.SetCondition(warpcondition * systemdamagepercent)
								pSequence = App.TGSequence_Create()
								pSet = pPlayer.GetContainingSet()
								pEmitFrom = App.TGModelUtils_CastNodeToAVObject(pPlayer.GetNode())
								pPlayerNode = pPlayer.GetNode()
								pAttachTo = pSet.GetEffectRoot() 
								vEmitPos  = qWarpChild.GetPosition()
								nanofx(pObject, pEvent)
			if DamagedSystemsNumber == 6:
				if pPhasers:
					pPhaserNumber = pPhasers.GetNumChildSubsystems()
					for iWeap in range(pPhaserNumber):
						qWeaponChild = pPhasers.GetChildSubsystem(iWeap)
						if qWeaponChild:
							if str(qWeaponChild) != str(pPhasers):
								damagechance = App.g_kSystemWrapper.GetRandomNumber(10)
								if (damagechance < 4):
									condition = qWeaponChild.GetCondition()
									qWeaponChild.SetCondition(condition * systemdamagepercent)
									pSequence = App.TGSequence_Create()
									pSet = pPlayer.GetContainingSet()
									pEmitFrom = App.TGModelUtils_CastNodeToAVObject(pPlayer.GetNode())
									pPlayerNode = pPlayer.GetNode()
									pAttachTo = pSet.GetEffectRoot()
									vEmitPos  = pSensors.GetPosition()
									nanofx(pObject, pEvent)
				if pPulse:
					pPulseNumber = pPulse.GetNumChildSubsystems()
					for iWeap in range(pPulseNumber):
						qWeaponChild = PulseWeapons.GetChildSubsystem(iWeap)
						if qWeaponChild:
							if str(qWeaponChild) != str(PulseWeapons):
								damagechance = App.g_kSystemWrapper.GetRandomNumber(10)
								if (damagechance < 4):
									condition = qWeaponChild.GetCondition()
									qWeaponChild.SetCondition(condition * systemdamagepercent)
									pSequence = App.TGSequence_Create()
									pSet = pPlayer.GetContainingSet()
									pEmitFrom = App.TGModelUtils_CastNodeToAVObject(pPlayer.GetNode())
									pPlayerNode = pPlayer.GetNode()
									pAttachTo = pSet.GetEffectRoot() 
									vEmitPos  = qWeaponChild.GetPosition()
									nanofx(pObject, pEvent)
	resetpower(pObject, pEvent)
	
def resetpower(pObject, pEvent):
	global choice, effect
	enablebuttons(pObject, pEvent)
	pPlayer = MissionLib.GetPlayer()
	pPower = pPlayer.GetPowerSubsystem()
	powerout = pPower.GetPowerOutput()
	conducit = pPower.GetMainConduitCapacity()
	backup = pPower.GetBackupConduitCapacity()
	effect = None
	if choice == 1:
		pPower.GetProperty().SetPowerOutput(powerout / 1.1)
		pPower.GetProperty().SetMainConduitCapacity(conducit / 1.1)
		pPower.GetProperty().SetBackupConduitCapacity(backup / 1.1)
	if choice == 2:
		pPower.GetProperty().SetPowerOutput(powerout / 1.25)
		pPower.GetProperty().SetMainConduitCapacity(conducit / 1.25)
		pPower.GetProperty().SetBackupConduitCapacity(backup / 1.25)
	if choice == 3:
		pPower.GetProperty().SetPowerOutput(powerout / 1.4)
		pPower.GetProperty().SetMainConduitCapacity(conducit / 1.4)
		pPower.GetProperty().SetBackupConduitCapacity(backup / 1.4)
	if choice == 4:
		pSound = App.TGSound_Create("sfx/Bridge/Crew/Tactical/AS_StayingAlive1.mp3", "EPE", 0)
		pSound.SetSFX(0)
		pSound.SetInterface(1)
		App.g_kSoundManager.PlaySound("EPE")
		pPower.GetProperty().SetPowerOutput(powerout / 1.6)
		pPower.GetProperty().SetMainConduitCapacity(conducit / 1.6)
		pPower.GetProperty().SetBackupConduitCapacity(backup / 1.6)

def nanofx(pObject, pEvent):
	global pSequence, pSet, pEmitFrom, pPlayerNode, pAttachTo, vEmitPos
	pPlayer = MissionLib.GetPlayer()
	vEmitDir  = App.NiPoint3(1, 1, 1)
	fSize     = pPlayer.GetRadius() * 0.10
	sFile     = Custom.NanoFXv2.ExplosionFX.ExpFX.GetNanoGfxFile("ExplosionGfx", "scripts/Custom/NanoFXv2/ExplosionFX/Gfx/Explosions/")
	pSound = Custom.NanoFXv2.ExplosionFX.ExpFX.CreateNanoSoundSeq(pPlayer, "ExpMedSfx")
	pSequence.AddAction(pSound)	
	pExplosion = Custom.NanoFXv2.NanoFX_ScriptActions.CreateControllerFX(sFile, pEmitFrom, pPlayerNode, fSize, vEmitPos, fLifeTime = 1.0)
	pSequence.AddAction(pExplosion)
	pSparks = Custom.NanoFXv2.ExplosionFX.ExpFX.CreateExpSparkSeq(fSize, pEmitFrom, pPlayerNode, vEmitPos, vEmitDir)
	pSequence.AddAction(pSparks, App.TGAction_CreateNull(), 0.5)
	pDebris = Custom.NanoFXv2.ExplosionFX.ExpFX.CreateNanoDebrisSeq(fSize, pEmitFrom, pSet.GetEffectRoot(), vEmitPos, vEmitDir)
	pSequence.AddAction(pDebris, App.TGAction_CreateNull(), 0.5)				
	pSequence.Play()